package foras.debug {
	/**
	 * ...
	 * @author 4as
	 */
	public class ForDebugCount {
		
		private static const DEBUG_GROUP:String = "default_debug";
		private static const oDebug:Object = new Object();
		
		/** Reset the Debug Counter */
		public static function resetDebug():void { DEBUG_COUNT = 0; }
		/** Whenever this function is called an internal DEBUG COUNTER is inremented, when it reaches a specifed 'step' the function will return 'true'. 
		 * 'false' on everything else, that is whenever DEBUG COUNTER != step. Function keeps incrementing even after reaching the 'step' */
		public static function countDebug(step:int = -1,group:String=null):Boolean {
			if(group == null) group = DEBUG_GROUP;
			if(oDebug[group] == null) oDebug[group] = 0; //this needs to be here to create the first var
			
			oDebug[group]++;
			return oDebug[group] == step;
		}
		/** Works the same way as "countDebug", but will return 'true' when 'step' is equal or small then internal DEBUG COUNTER.
		 * In otherworks words it will return 'true' once "countDebug" equals 'step' and always afterwards, till the DEBUG COUNTER is reseted.
		 * Does no incrementing. */
		public static function fillDebug(step:int=-1,group:String=null):Boolean {
			return oDebug[group] >= step;
		}
		/** Works the same as "countDebug" but does no incrementing */
		public static function isDebug(step:int=-1,group:String=null):Boolean {
			return oDebug[group] == step;
		}
		
	}

}