﻿package foras.net {
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	
	public class ForNetConfig {
		
		public static const CONFIG_LOADED:Number = 0xff000001;
		public static const CONFIG_FAILED:Number = 0xff000002;
		public static const CONFIG_ERROR:Number = 0xff000003;

		private var fCallback:Function;
		private var urlLoad:URLLoader;
		private var urlReq:URLRequest;

		public function ForNetConfig() {
			urlLoad = new URLLoader();
			urlLoad.addEventListener(Event.COMPLETE,onFileLoad);
			urlLoad.addEventListener(IOErrorEvent.IO_ERROR,onFileError);
			urlLoad.addEventListener(SecurityErrorEvent.SECURITY_ERROR,onFileError);
		}
		
		public function loadFile(callback:Function,address:String):void {
			fCallback = callback;
			urlReq = new URLRequest(address);
			
			try{
				urlLoad.load(urlReq);
			} catch(e:Error) {
				onFileError(null);
			}
		}

		//
		// Events
		protected function onFileLoad(e:Event):void {
			var o:Object = new Object();
			var idx:Number = 0;
			while(idx!=-1) idx = getSetting(urlLoad.data, idx, o);
			fCallback(CONFIG_LOADED,o);
		}
		
		protected function onFileError(e:Event):void {
			fCallback(CONFIG_FAILED);
		}
		
		
		//
		// Parsing values
		private function getSetting(t:String,i:Number,o:Object):Number {
			
			var i1:Number = i;
			var i2:Number = 0;
			var vname:String;
			var vvalue:String;
			
			//
			// Variable name
			i2 = t.indexOf("=",i1);
			if(i2==-1) return -1;
			var loop:Boolean = true;
			while(loop) {
				switch( t.charAt(i1).toLowerCase() ) {
					case " ":
					case "\n":
					case "\r":
					case "\t":
						i1++;
						break;
					case "=":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \"=\" sign!");
						return -1;
					case ";":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \";\" sign!");
						return -1;
					default:
						loop=false;
						break;
				}
			}
			
			loop = true;
			while(loop) {
				switch( t.charAt(i2-1).toLowerCase() ) {
					case " ":
					case "\n":
					case "\r":
					case "\t":
						i2--;
						break;
					case "=":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \"=\" sign!");
						return -1;
					case ";":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \";\" sign!");
						return -1;
					default:
						loop=false;
						break;
				}
			}
			
			vname = t.substring(i1,i2);
			
			//
			// Variable value
			i1 = t.indexOf("=",i1)+1;
			i2 = t.indexOf(";",i1);
			if(i2==-1) return -1;
			loop = true;
			while(loop) {
				switch( t.charAt(i1).toLowerCase() ) {
					case " ":
					case "\n":
					case "\r":
					case "\t":
						i1++;
						break;
					case "=":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \"=\" sign!");
						return -1;
					case ";":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \";\" sign!");
						return -1;
					default:
						loop=false;
						break;
				}
			}
			
			loop = true;
			while(loop) {
				switch( t.charAt(i2-1).toLowerCase() ) {
					case " ":
					case "\n":
					case "\r":
					case "\t":
						i2--;
						break;
					case "=":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \"=\" sign!");
						return -1;
					case ";":
						fCallback(CONFIG_ERROR,"Error parsing config file! Unexpected \";\" sign!");
						return -1;
					default:
						loop=false;
						break;
				}
			}
			vvalue = t.substring(i1,i2);
			
			//
			// Saving extracted value
			o[vname] = vvalue;

			return t.indexOf(";",i1)+1;
		}
		

	}
	
}
