﻿package foras.net {
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	
	public class ForNetParser {
		
		public static const PARSE_LOADED:Number = 0xff030001;
		public static const PARSE_FAILED:Number = 0xff030002;
		
		private var fCallback:Function;
		private var urlLoad:URLLoader;
		private var sDeli:String;
		private var bLoading:Boolean;

		public function ForNetParser() {
			urlLoad = new URLLoader();
			bLoading = false;
		}
		public function load(callback:Function,address:String,vars:Object=null,deli:String=" "):void {
			if(bLoading) throw new Error("ForNetParser::load - There is already load operation in progress!");
			sDeli = deli;
			fCallback = callback;
			
			bLoading = true;
			urlLoad.addEventListener(Event.COMPLETE, onFile);
			urlLoad.addEventListener(IOErrorEvent.IO_ERROR, onFileFail);
			
			var rReq:URLRequest = new URLRequest(address);
			rReq.method = URLRequestMethod.POST;
			if(vars!=null) {
				rReq.data = new URLVariables();
				for(var item:String in vars) {
					rReq.data[item] = vars[item];
				}
			}
			try {
				urlLoad.load(rReq);
			} catch(e:Error) {
				bLoading = false;
				urlLoad.removeEventListener(Event.COMPLETE, onFile);
				urlLoad.removeEventListener(IOErrorEvent.IO_ERROR, onFileFail);
				fCallback( PARSE_FAILED,"ForNetParse::load - Unknow Error");
			}
		}
		
		public function isLoading():Boolean {
			return bLoading;
		}
		
		//
		// Events
		private function onFile(e:Event):void {
			var s:String = String(urlLoad.data);
			var i:Number = s.indexOf("#result=");
			if(i==-1) {
				fCallback( PARSE_FAILED,"ForNetParse::onFile - Unknow Result: "+s);
				return;
			}
			s = s.substring(i+8,s.indexOf("#end#"));
			var a:Array = s.split(sDeli);
			var res:Number = Number(a.shift());
			if(res==0) {
				bLoading = false;
				urlLoad.removeEventListener(Event.COMPLETE, onFile);
				urlLoad.removeEventListener(IOErrorEvent.IO_ERROR, onFileFail);
				fCallback( PARSE_FAILED,"ForNetParse::onFile - Error result: "+s );
			}
			else {
				if(a == null || a.length<1) fCallback( PARSE_FAILED,"ForNetParse::onFile - Empty Result" );
				bLoading = false;
				urlLoad.removeEventListener(Event.COMPLETE, onFile);
				urlLoad.removeEventListener(IOErrorEvent.IO_ERROR, onFileFail);
				fCallback( PARSE_LOADED, a );
			}
		}
		
		private function onFileFail(e:Event):void {
			bLoading = false;
			urlLoad.removeEventListener(Event.COMPLETE, onFile);
			urlLoad.removeEventListener(IOErrorEvent.IO_ERROR, onFileFail);
			fCallback( PARSE_FAILED,"ForNetParse::onFile - IO Error" );
		}

	}
	
}
