package foras.tools {
	
	import foras.tools.core.ForMazePath;
	import foras.utils.ForRandomPick;

	public class ForMazeGenerator {
		
		private var aMap:Vector.<Vector.<int>>;
		private var aNode:Vector.<Vector.<int>>;
		
		private var SIZE_X:int;
		private var SIZE_Y:int;
		private var NODE_AMOUNT:int;
		
		public function ForMazeGenerator() {
			
		}
		
		public function getRandomMaze(width:int, height:int):Vector.<Vector.<int>> {
			SIZE_X = width;
			SIZE_Y = height;
			NODE_AMOUNT = int( (height - 1) / 2 );
			
			aNode = new Vector.<Vector.<int>>();
			var a:Vector.<int>;
			
			aMap = new Vector.<Vector.<int>>(SIZE_X);
			var i:int = 0;
			var j:int = 0;
			var v:Vector.<int>;
			
			for  (i = 0; i < aMap.length; i++) {
				aMap[i] = new Vector.<int>(SIZE_Y);
				for (j = 0; j < aMap[i].length; j++) {
					if ( i == SIZE_X-1 || j == SIZE_Y-1 ) {
						aMap[i][j] = 0;
					} else if( (i + 1) % 2 == 0 && (j + 1) % 2 == 0 ) {
						aMap[i][j] = 1;
						v = new Vector.<int>();
						v.push(i);
						v.push(j);
						aNode.push(v);
					} else {
						aMap[i][j] = 0;
					}
				}
			}
			
			// carving pathes
			var aPath:Vector.<ForMazePath> = new Vector.<ForMazePath>();
			aPath.push( new ForMazePath(ForRandomPick.pickFrom(aNode.length)) );
			while (aPath.length > 0) {
				for each(var path:ForMazePath in aPath) {
					if ( !path.drawPath(aNode, aMap,NODE_AMOUNT) ) aPath.splice(aPath.indexOf(path), 1);
					else {
						a = aNode[path.current];
						switch( int(Math.random()*4) ) {
							case 0: // up
								if (a[1] > 2 && aMap[ a[0] ][ a[1] - 1 ] == 0 ) aPath.push( new ForMazePath(path.current) );
								break;
							case 1: // down
								if (a[1] < SIZE_Y-3 && aMap[ a[0] ][ a[1] + 1 ] == 0 ) aPath.push( new ForMazePath(path.current) );
								break;
							case 2: // left
								if (a[0] > 2 && aMap[ a[0]-1 ][ a[1]  ] == 0 ) aPath.push( new ForMazePath(path.current) );
								break;
							case 3: // right
								if (a[0] < SIZE_X-3 && aMap[ a[0]+1 ][ a[1] ] == 0 ) aPath.push( new ForMazePath(path.current) );
								break;
						}
					}
				}
			}
			
			// connecting floating (not connected) nodes
			for ( i = 0; i < aNode.length;i++) {
				if (checkNode(aNode[i][0], aNode[i][1])) defloatNode(i);
			}
			
			return aMap;
		}
		
		private function defloatNode(i:int):void {
			var picker:ForRandomPick = new ForRandomPick([0, 1, 2, 3]);
			var a:Vector.<int> = aNode[i];
			while(picker.getSetSize()>0) switch( picker.pickAndBlock() ) {
				case 0: // up
					if (a[1] <= 2) continue;
					if ( checkNode(a[0], a[1] - 2) ) {
						aMap[ a[0] ][ a[1] - 1 ] = 1;
						defloatNode(i - 1);
					}
					aMap[ a[0] ][ a[1] - 1 ] = 1;
					return;
				case 1: // down
					if (a[1] >= SIZE_Y-3 ) continue;
					if ( checkNode(a[0], a[1] + 2) ) {
						aMap[ a[0] ][ a[1] + 1 ] = 1;
						defloatNode(i + 1);
					}
					aMap[ a[0] ][ a[1] + 1 ] = 1;
					return;
				case 2: // left
					if (a[0] <= 2 ) continue;
					if ( checkNode(a[0]-2, a[1] ) ) {
						aMap[ a[0]-1 ][ a[1]] = 1;
						defloatNode(i - NODE_AMOUNT);
					}
					aMap[ a[0]-1 ][ a[1]  ] = 1;
					return;
				case 3: // right
					if (a[0] >= SIZE_X-3 ) continue;
					if ( checkNode(a[0]+2, a[1] ) ) {
						aMap[ a[0]+1 ][ a[1]] = 1;
						defloatNode(i + NODE_AMOUNT);
					}
					aMap[ a[0]+1 ][ a[1]  ] = 1;
					return;
			}
		}
		
		private function checkNode(i:int, j:int):Boolean {
			if (i<1 || i>SIZE_X-1 || j<1 || j>SIZE_Y-1) return false;
			return aMap[i-1][j]==0 && aMap[i+1][j]==0 && aMap[i][j-1]==0 && aMap[i][j+1]==0;
		}
		
	}

}