package foras.tools.core {
	
	import foras.utils.ForRandomPick;
	
	public class ForMazePath {
		
		private var picker:ForRandomPick;
		public var current:int;
		
		public function ForMazePath(cur:int):void {
			current = cur;
			picker = new foras.utils.ForRandomPick([0, 1, 2, 3]);
		}
		
		public function drawPath(aNode:Vector.<Vector.<int>>, aMap:Vector.<Vector.<int>>,size:int):Boolean {
			var a:Vector.<int>;
			while(picker.getSetSize() > 0){
				a = aNode[current];
				switch(picker.pick()){
					case 0: // up
						//trace("up",nCur, "node:", a[0], a[1], "target", aMap[ a[0] ][ a[1] - 1 ]);
						if(a[1] > 2 && aMap[a[0]][a[1] - 1] == 0 && checkNode(a[0], a[1] - 2, aMap)){
							aMap[a[0]][a[1] - 1] = 1;
							current = current - 1;
							picker.reset();
							return true;
						} else
							picker.blockIndex(0);
						break;
					case 1: // down
						//trace("down",nCur, "node:", a[0], a[1], "target", aMap[ a[0] ][ a[1] + 1 ]);
						if(a[1] < aMap[a[0]].length - 3 && aMap[a[0]][a[1] + 1] == 0 && checkNode(a[0], a[1] + 2, aMap)){
							aMap[a[0]][a[1] + 1] = 1;
							current = current + 1;
							picker.reset();
							return true;
						} else
							picker.blockIndex(1);
						break;
					case 2: // left
						//trace("left",nCur, "node:", a[0], a[1], "target", aMap[ a[0]-1 ][ a[1] ]);
						if(a[0] > 2 && aMap[a[0] - 1][a[1]] == 0 && checkNode(a[0] - 2, a[1], aMap)){
							aMap[a[0] - 1][a[1]] = 1;
							current = current - size;
							picker.reset();
							return true;
						} else
							picker.blockIndex(2);
						break;
					case 3: // right
						//trace("right",nCur, "node:", a[0], a[1], "target", aMap[ a[0]+1 ][ a[1] ]);
						if(a[0] < aMap.length  - 3 && aMap[a[0] + 1][a[1]] == 0 && checkNode(a[0] + 2, a[1] - 2, aMap)){
							aMap[a[0] + 1][a[1]] = 1;
							current = current + size;
							picker.reset();
							return true;
						} else
							picker.blockIndex(3);
						break;
				
				}
			}
			return false;
		}
		
		private function checkNode(i:int, j:int, aMap:Vector.<Vector.<int>>):Boolean {
			if(i < 1 || i > aMap.length - 1 || j < 1 || j > aMap[i].length - 1)
				return false;
			return aMap[i - 1][j] == 0 && aMap[i + 1][j] == 0 && aMap[i][j - 1] == 0 && aMap[i][j + 1] == 0;
		}
	
	}

}