﻿package foras.utils.core{

	public class ForListEntry {

		public var prev:ForListEntry;
		public var next:ForListEntry;
		public var item:*;

		public function ForListEntry(content:Object,before:ForListEntry=null,after:ForListEntry=null) {
			item=content;
			prev=before;
			next=after;
		}

		public function toString():String {
			return item.toString();
		}

		public static function sort(list:ForListEntry,compare:Function):ForListEntry {
			if (list==null || list.next==null || compare==null) {
				return list;
			}
			
			var head:ForListEntry=list,left:ForListEntry,right:ForListEntry,tmp:ForListEntry,tail:ForListEntry;
			var list_size:int=1,num_merge:int,left_size:int,right_size:int;

			do {
				left=head;
				head=tail=null;
				num_merge=0;

				while (left) {
					num_merge++;
					left_size = 0;
					right = left;
					while (right && left_size<list_size) {
						left_size++;
						right=right.next;
					}

					right_size=list_size;

					while (left_size > 0 || (right_size > 0 && right)) {
						if (left_size == 0) {tmp=right;right=right.next; right_size--;}
						else if (right_size == 0 || !right) {tmp=left;left=left.next;left_size--;}
						else if (compare(left.item, right.item) <= 0) {tmp=left;left=left.next;left_size--;}
						else {tmp=right;right=right.next;right_size--;}
						
						if (tail) tail.next=tmp;
						else head=tmp;
						
						tmp.prev=tail;
						tail=tmp;
					}
					left=right;
				}

				tail.next=null;
				list_size<<=1;
			} while (num_merge>1);
			
			return head;
		}

	}

}